""" 
Monitor Picando Codigo
(C) Fernando Briano 2007
www.picandocodigo.net

Codigo monitor bateria basado en battery-monitor (kde-look.org)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
"""
#this import statement allows access to the karamba functions
import karamba
import os
import sys


#this is called when your widget is initialized
def initWidget(widget):
    global empty;
    global low;
    global two_thirds;
    global full;
    global empty_charge;
    global low_charge;
    global two_thirds_charge;
    global full_charge;
    global statusText;
    
    empty = karamba.createImage(widget, 0, 120, "./battery_images/battery_empty.png");
    low = karamba.createImage(widget, 0, 120, "./battery_images/battery_low.png");
    two_thirds = karamba.createImage(widget, 0, 120, "./battery_images/battery_two_thirds.png");
    full = karamba.createImage(widget, 0, 120, "./battery_images/battery_full.png");
    empty_charge = karamba.createImage(widget, 0, 120, "./battery_images/battery_empty_charge.png");
    low_charge = karamba.createImage(widget, 0, 120, "./battery_images/battery_low_charge.png");
    two_thirds_charge = karamba.createImage(widget, 0, 120, "./battery_images/battery_two_thirds_charge.png");
    full_charge = karamba.createImage(widget, 0, 120, "./battery_images/battery_full_charge.png");
        
    karamba.hideImage(widget, empty);
    karamba.hideImage(widget, low);
    karamba.hideImage(widget, two_thirds);
    karamba.hideImage(widget, full);
    
    statusText = karamba.createText(widget, 35, 180, 0, 0, "");
    
    karamba.redrawWidget(widget);
    
    pollACPI(widget);
    
    karamba.redrawWidget(widget);
    
    pass

#This is called when your widget is closed.  You can use this to clean
#up open files, etc.  You don't need to delete text and images in your
#theme.  That is done automatically.  This callback is just for cleaning up
#external things.  Most people don't need to put anything here.
def widgetClosed(widget):
    pass

#This function runs acpi to check what the current status of the battery is
def pollACPI(widget):
    global handle;
    global percentage;
    global value;
    global statusText;
    
    #handle = os.popen("acpi | awk '{print $4}' | grep -o '[0-9]*'", "r");
    handle = os.popen("acpi | awk '{print $3$4}'", "r");
    text = handle.read();
    
    status = text.split(',')[0];
    percentage = text.split(',')[1];
    percentage = percentage.strip('%');

    value = int(percentage);
    
    if status == "discharging":
       if value <= 100 and value > 70:         
	  karamba.hideImage(widget, empty_charge);
          karamba.hideImage(widget, low_charge);
          karamba.hideImage(widget, two_thirds_charge);
          karamba.hideImage(widget, full_charge);
          karamba.hideImage(widget, empty);
          karamba.hideImage(widget, low);
          karamba.hideImage(widget, two_thirds);
          karamba.showImage(widget, full);
       elif value <= 70 and value > 40:
	  karamba.hideImage(widget, empty_charge);
          karamba.hideImage(widget, low_charge);
          karamba.hideImage(widget, two_thirds_charge);
          karamba.hideImage(widget, full_charge);
          karamba.hideImage(widget, empty);
          karamba.hideImage(widget, low);
          karamba.hideImage(widget, full);
          karamba.showImage(widget, two_thirds);
       elif value <= 40 and value > 15:
          karamba.hideImage(widget, empty_charge);
          karamba.hideImage(widget, low_charge);
          karamba.hideImage(widget, two_thirds_charge);
          karamba.hideImage(widget, full_charge);
          karamba.hideImage(widget, empty);
          karamba.hideImage(widget, two_thirds);
          karamba.hideImage(widget, full);
          karamba.showImage(widget, low);
       elif value <= 15 and value > 0:
	  karamba.hideImage(widget, empty_charge);
          karamba.hideImage(widget, low_charge);
          karamba.hideImage(widget, two_thirds_charge);
          karamba.hideImage(widget, full_charge);
          karamba.hideImage(widget, low);
          karamba.hideImage(widget, two_thirds);
          karamba.hideImage(widget, full);
          karamba.showImage(widget, empty);
    else:
       if value <= 100 and value > 70:
          karamba.hideImage(widget, low);
          karamba.hideImage(widget, two_thirds);
          karamba.hideImage(widget, full);
          karamba.hideImage(widget, empty);
          karamba.hideImage(widget, empty_charge);
          karamba.hideImage(widget, low_charge);
          karamba.hideImage(widget, two_thirds_charge);
          karamba.showImage(widget, full_charge);
       elif value <= 70 and value > 40:
          karamba.hideImage(widget, low);
          karamba.hideImage(widget, two_thirds);
          karamba.hideImage(widget, full);
          karamba.hideImage(widget, empty);
          karamba.hideImage(widget, empty_charge);
          karamba.hideImage(widget, low_charge);
          karamba.hideImage(widget, full_charge);
          karamba.showImage(widget, two_thirds_charge);
       elif value <= 40 and value > 15:
          karamba.hideImage(widget, low);
          karamba.hideImage(widget, two_thirds);
          karamba.hideImage(widget, full);
          karamba.hideImage(widget, empty);
          karamba.hideImage(widget, empty_charge);
          karamba.hideImage(widget, two_thirds_charge);
          karamba.hideImage(widget, full_charge);
          karamba.showImage(widget, low_charge);
       elif value <= 15 and value > 0:
          karamba.hideImage(widget, low);
          karamba.hideImage(widget, two_thirds);
          karamba.hideImage(widget, full);
          karamba.hideImage(widget, empty);
          karamba.hideImage(widget, low_charge);
          karamba.hideImage(widget, two_thirds_charge);
          karamba.hideImage(widget, full_charge);
          karamba.showImage(widget, empty_charge);
	      
    karamba.setTextAlign(widget, statusText, "CENTER")
    karamba.changeTextColor(widget, statusText, 255, 255, 255)
    karamba.changeTextShadow(widget, statusText, 0)
    karamba.changeTextSize(widget, statusText, 10)
    karamba.changeTextFont(widget, statusText, "Monospace")
    karamba.moveText(widget, statusText, 35, 180)
    karamba.changeText(widget, statusText, percentage + '%');
       
    karamba.redrawWidget(widget)
    
    pass